## ntfy 0.0.6

=== DESCRIPTION ===
Package: ntfy
Title: Lightweight Wrapper to the 'ntfy.sh' Service
Version: 0.0.6
Authors@R: 
    c(person("Jonathan", "Carroll", 
             email = "rpkg@jcarroll.com.au", 
             role = c("aut", "cre"), 
             comment = c(ORCID = "0000-0002-1404-5264")),
      person(given = "Andrew",
             family = "Heiss",
             role = "ctb",
             email = "andrew@andrewheiss.com",
             comment = c(ORCID = "0000-0002-3948-3914"))
    )
Maintainer: Jonathan Carroll <rpkg@jcarroll.com.au>
Description: The 'ntfy' (pronounce: notify) service is a simple HTTP-based pub-sub
    notification service. It allows you to send notifications to your phone or 
    desktop via scripts from any computer, entirely without signup, cost or 
    setup. It's also open source if you want to run your own. 
    Visit <https://ntfy.sh> for more details.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.2
Imports: httr2, jsonlite
URL: https://github.com/jonocarroll/ntfy
BugReports: https://github.com/jonocarroll/ntfy/issues
Depends: R (>= 4.1)
LazyData: true
Suggests: ggplot2, testthat (>= 3.0.0)
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2024-11-04 08:40:18 UTC; jono
Author: Jonathan Carroll [aut, cre] (<https://orcid.org/0000-0002-1404-5264>),
  Andrew Heiss [ctb] (<https://orcid.org/0000-0002-3948-3914>)
Repository: CRAN
Date/Publication: 2024-11-06 15:20:02 UTC

## ntfy 0.1.0

=== DESCRIPTION ===
Package: ntfy
Title: Lightweight Wrapper to the 'ntfy.sh' Service
Version: 0.1.0
Authors@R: 
    c(person("Jonathan", "Carroll", 
             email = "rpkg@jcarroll.com.au", 
             role = c("aut", "cre"), 
             comment = c(ORCID = "0000-0002-1404-5264")),
      person(given = "Andrew",
             family = "Heiss",
             role = "ctb",
             email = "andrew@andrewheiss.com",
             comment = c(ORCID = "0000-0002-3948-3914")),
      person(given = "Hadley",
             family = "Wickham",
             role = "ctb",
             email = "h.wickham@gmail.com",
             comment = c(ORCID = "0000-0003-4757-117X"))
    )
Maintainer: Jonathan Carroll <rpkg@jcarroll.com.au>
Description: The 'ntfy' (pronounce: notify) service is a simple HTTP-based pub-sub
    notification service. It allows you to send notifications to your phone or 
    desktop via scripts from any computer, entirely without signup, cost or 
    setup. It's also open source if you want to run your own. 
    Visit <https://ntfy.sh> for more details.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3
Imports: httr2, jsonlite
URL: https://github.com/jonocarroll/ntfy,
        https://jonocarroll.github.io/ntfy/
BugReports: https://github.com/jonocarroll/ntfy/issues
Depends: R (>= 4.1)
LazyData: true
Suggests: ggplot2, testthat (>= 3.0.0), withr
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2025-10-25 12:04:14 UTC; jono
Author: Jonathan Carroll [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1404-5264>),
  Andrew Heiss [ctb] (ORCID: <https://orcid.org/0000-0002-3948-3914>),
  Hadley Wickham [ctb] (ORCID: <https://orcid.org/0000-0003-4757-117X>)
Repository: CRAN
Date/Publication: 2025-10-26 18:20:02 UTC

## ntfy 2.11.0

=== Makefile ===
MAKEFLAGS := --jobs=1
PYTHON := python3
PIP := pip3
VERSION := $(shell git describe --tag)
COMMIT := $(shell git rev-parse --short HEAD)

.PHONY:

help:
	@echo "Typical commands (more see below):"
	@echo "  make build                      - Build web app, documentation and server/client (sloowwww)"
	@echo "  make cli-linux-amd64            - Build server/client binary (amd64, no web app or docs)"
	@echo "  make install-linux-amd64        - Install ntfy binary to /usr/bin/ntfy (amd64)"
	@echo "  make web                        - Build the web app"
	@echo "  make docs                       - Build the documentation"
	@echo "  make check                      - Run all tests, vetting/formatting checks and linters"
	@echo
	@echo "Build everything:"
	@echo "  make build                      - Build web app, documentation and server/client"
	@echo "  make clean                      - Clean build/dist folders"
	@echo
	@echo "Build server & client (using GoReleaser, not release version):"
	@echo "  make cli                        - Build server & client (all architectures)"
	@echo "  make cli-linux-amd64            - Build server & client (Linux, amd64 only)"
	@echo "  make cli-linux-armv6            - Build server & client (Linux, armv6 only)"
	@echo "  make cli-linux-armv7            - Build server & client (Linux, armv7 only)"
	@echo "  make cli-linux-arm64            - Build server & client (Linux, arm64 only)"
	@echo "  make cli-windows-amd64          - Build client (Windows, amd64 only)"
	@echo "  make cli-darwin-all             - Build client (macOS, arm64+amd64 universal binary)"
	@echo
	@echo "Build server & client (without GoReleaser):"
	@echo "  make cli-linux-server           - Build client & server (no GoReleaser, current arch, Linux)"
	@echo "  make cli-darwin-server          - Build client & server (no GoReleaser, current arch, macOS)"
	@echo "  make cli-client                 - Build client only (no GoReleaser, current arch, Linux/macOS/Windows)"
	@echo
	@echo "Build dev Docker:"
	@echo "  make docker-dev                 - Build client & server for current architecture using Docker only"
	@echo
	@echo "Build web app:"
	@echo "  make web                        - Build the web app"
	@echo "  make web-deps                   - Install web app dependencies (npm install the universe)"
	@echo "  make web-build                  - Actually build the web app"
	@echo "  make web-lint                   - Run eslint on the web app"
	@echo "  make web-fmt                    - Run prettier on the web app"
	@echo "  make web-fmt-check              - Run prettier on the web app, but don't change anything"
	@echo
	@echo "Build documentation:"
	@echo "  make docs                       - Build the documentation"
	@echo "  make docs-deps                  - Install Python dependencies (pip3 install)"
	@echo "  make docs-build                 - Actually build the documentation"
	@echo
	@echo "Test/check:"
	@echo "  make test                       - Run tests"
	@echo "  make race                       - Run tests with -race flag"
	@echo "  make coverage                   - Run tests and show coverage"
	@echo "  make coverage-html              - Run tests and show coverage (as HTML)"
	@echo "  make coverage-upload            - Upload coverage results to codecov.io"
	@echo
	@echo "Lint/format:"
	@echo "  make fmt                        - Run 'go fmt'"
	@echo "  make fmt-check                  - Run 'go fmt', but don't change anything"
	@echo "  make vet                        - Run 'go vet'"
	@echo "  make lint                       - Run 'golint'"
	@echo "  make staticcheck                - Run 'staticcheck'"
	@echo
	@echo "Releasing:"
	@echo "  make release                    - Create a release"
	@echo "  make release-snapshot           - Create a test release"
	@echo
	@echo "Install locally (requires sudo):"
	@echo "  make install-linux-amd64        - Copy amd64 binary from dist/ to /usr/bin/ntfy"
	@echo "  make install-linux-armv6        - Copy armv6 binary from dist/ to /usr/bin/ntfy"
	@echo "  make install-linux-armv7        - Copy armv7 binary from dist/ to /usr/bin/ntfy"
	@echo "  make install-linux-arm64        - Copy arm64 binary from dist/ to /usr/bin/ntfy"
	@echo "  make install-linux-deb-amd64    - Install .deb from dist/ (amd64 only)"
	@echo "  make install-linux-deb-armv6    - Install .deb from dist/ (armv6 only)"
	@echo "  make install-linux-deb-armv7    - Install .deb from dist/ (armv7 only)"
	@echo "  make install-linux-deb-arm64    - Install .deb from dist/ (arm64 only)"


# Building everything

clean: .PHONY
	rm -rf dist build server/docs server/site

build: web docs cli

update: web-deps-update cli-deps-update docs-deps-update
	docker pull alpine

docker-dev:
	docker build \
		--file ./Dockerfile-build \
		--tag binwiederhier/ntfy:$(VERSION) \
		--tag binwiederhier/ntfy:dev \
		--build-arg VERSION=$(VERSION) \
		--build-arg COMMIT=$(COMMIT) \
		./


# Ubuntu-specific

build-deps-ubuntu:
	sudo apt-get update
	sudo apt-get install -y \
		curl \
		gcc-aarch64-linux-gnu \
		gcc-arm-linux-gnueabi \
		python3 \
		python3-venv \
		jq
	which pip3 || sudo apt-get install -y python3-pip


# Documentation

docs: docs-deps docs-build

docs-venv: .PHONY
	$(PYTHON) -m venv ./venv

docs-build: docs-venv
	(. venv/bin/activate && $(PYTHON) -m mkdocs build)

docs-deps: docs-venv
	(. venv/bin/activate && $(PIP) install -r requirements.txt)

docs-deps-update: .PHONY
	(. venv/bin/activate && $(PIP) install -r requirements.txt --upgrade)


# Web app

web: web-deps web-build

web-build:
	cd web \
		&& npm run build \
		&& mv build/index.html build/app.html \
		&& rm -rf ../server/site \
		&& mv build ../server/site \
		&& rm \
			../server/site/config.js

web-deps:
	cd web && npm install
	# If this fails for .svg files, optimize them with svgo

web-deps-update:
	cd web && npm update

web-fmt:
	cd web && npm run format

web-fmt-check:
	cd web && npm run format:check

web-lint:
	cd web && npm run lint

# Main server/client build

cli: cli-deps
	goreleaser build --snapshot --clean

cli-linux-amd64: cli-deps-static-sites
	goreleaser build --snapshot --clean --id ntfy_linux_amd64

cli-linux-armv6: cli-deps-static-sites cli-deps-gcc-armv6-armv7
	goreleaser build --snapshot --clean --id ntfy_linux_armv6

cli-linux-armv7: cli-deps-static-sites cli-deps-gcc-armv6-armv7
	goreleaser build --snapshot --clean --id ntfy_linux_armv7

cli-linux-arm64: cli-deps-static-sites cli-deps-gcc-arm64
	goreleaser build --snapshot --clean --id ntfy_linux_arm64

cli-windows-amd64: cli-deps-static-sites
	goreleaser build --snapshot --clean --id ntfy_windows_amd64

cli-darwin-all: cli-deps-static-sites
	goreleaser build --snapshot --clean --id ntfy_darwin_all

cli-linux-server: cli-deps-static-sites
	# This is a target to build the CLI (including the server) manually.
	# Use this for development, if you really don't want to install GoReleaser ...
	mkdir -p dist/ntfy_linux_server server/docs
	CGO_ENABLED=1 go build \
		-o dist/ntfy_linux_server/ntfy \
		-tags sqlite_omit_load_extension,osusergo,netgo \
		-ldflags \
		"-linkmode=external -extldflags=-static -s -w -X main.version=$(VERSION) -X main.commit=$(COMMIT) -X main.date=$(shell date +%s)"

cli-darwin-server: cli-deps-static-sites
	# This is a target to build the CLI (including the server) manually.
	# Use this for macOS/iOS development, so you have a local server to test with.
	mkdir -p dist/ntfy_darwin_server server/docs
	CGO_ENABLED=1 go build \
		-o dist/ntfy_darwin_server/ntfy \
		-tags sqlite_omit_load_extension,osusergo,netgo \
		-ldflags \
		"-linkmode=external -s -w -X main.version=$(VERSION) -X main.commit=$(COMMIT) -X main.date=$(shell date +%s)"

cli-client: cli-deps-static-sites
	# This is a target to build the CLI (excluding the server) manually. This should work on Linux/macOS/Windows.
	# Use this for development, if you really don't want to install GoReleaser ...
	mkdir -p dist/ntfy_client server/docs
	CGO_ENABLED=0 go build \
		-o dist/ntfy_client/ntfy \
		-tags noserver \
		-ldflags \
		"-X main.version=$(VERSION) -X main.commit=$(COMMIT) -X main.date=$(shell date +%s)"

cli-deps: cli-deps-static-sites cli-deps-all cli-deps-gcc

cli-deps-gcc: cli-deps-gcc-armv6-armv7 cli-deps-gcc-arm64

cli-deps-static-sites:
	mkdir -p server/docs server/site
	touch server/docs/index.html server/site/app.html

cli-deps-all:
	go install github.com/goreleaser/goreleaser@latest

cli-deps-gcc-armv6-armv7:
	which arm-linux-gnueabi-gcc || { echo "ERROR: ARMv6/ARMv7 cross compiler not installed. On Ubuntu, run: apt install gcc-arm-linux-gnueabi"; exit 1; }

cli-deps-gcc-arm64:
	which aarch64-linux-gnu-gcc || { echo "ERROR: ARM64 cross compiler not installed. On Ubuntu, run: apt install gcc-aarch64-linux-gnu"; exit 1; }

cli-deps-update:
	go get -u
	go install honnef.co/go/tools/cmd/staticcheck@latest
	go install golang.org/x/lint/golint@latest
	go install github.com/goreleaser/goreleaser@latest

cli-build-results:
	cat dist/config.yaml
	[ -f dist/artifacts.json ] && cat dist/artifacts.json | jq . || true
	[ -f dist/metadata.json ] && cat dist/metadata.json | jq . || true
	[ -f dist/checksums.txt ] && cat dist/checksums.txt || true
	find dist -maxdepth 2 -type f \
		\( -name '*.deb' -or -name '*.rpm' -or -name '*.zip' -or -name '*.tar.gz' -or -name 'ntfy' \) \
		-and -not -path 'dist/goreleaserdocker*' \
		-exec sha256sum {} \;

# Test/check targets

check: test web-fmt-check fmt-check vet web-lint lint staticcheck

test: .PHONY
	go test $(shell go list ./... | grep -vE 'ntfy/(test|examples|tools)')

testv: .PHONY
	go test -v $(shell go list ./... | grep -vE 'ntfy/(test|examples|tools)')

race: .PHONY
	go test -v -race $(shell go list ./... | grep -vE 'ntfy/(test|examples|tools)')

coverage:
	mkdir -p build/coverage
	go test -v -race -coverprofile=build/coverage/coverage.txt -covermode=atomic $(shell go list ./... | grep -vE 'ntfy/(test|examples|tools)')
	go tool cover -func build/coverage/coverage.txt

coverage-html:
	mkdir -p build/coverage
	go test -race -coverprofile=build/coverage/coverage.txt -covermode=atomic $(shell go list ./... | grep -vE 'ntfy/(test|examples|tools)')
	go tool cover -html build/coverage/coverage.txt

coverage-upload:
	cd build/coverage && (curl -s https://codecov.io/bash | bash)


# Lint/formatting targets

fmt: web-fmt
	gofmt -s -w .

fmt-check:
	test -z $(shell gofmt -l .)

vet:
	go vet ./...

lint:
	which golint || go install golang.org/x/lint/golint@latest
	go list ./... | grep -v /vendor/ | xargs -L1 golint -set_exit_status

staticcheck: .PHONY
	rm -rf build/staticcheck
	which staticcheck || go install honnef.co/go/tools/cmd/staticcheck@latest
	mkdir -p build/staticcheck
	ln -s "go" build/staticcheck/go
	PATH="$(PWD)/build/staticcheck:$(PATH)" staticcheck ./...
	rm -rf build/staticcheck


# Releasing targets

release: clean cli-deps release-checks docs web check
	goreleaser release --clean

release-snapshot: clean cli-deps docs web check
	goreleaser release --snapshot --skip-publish --clean

release-checks:
	$(eval LATEST_TAG := $(shell git describe --abbrev=0 --tags | cut -c2-))
	if ! grep -q $(LATEST_TAG) docs/install.md; then\
	 	echo "ERROR: Must update docs/install.md with latest tag first.";\
	 	exit 1;\
	fi
	if ! grep -q $(LATEST_TAG) docs/releases.md; then\
		echo "ERROR: Must update docs/releases.md with latest tag first.";\
		exit 1;\
	fi
	if [ -n "$(shell git status -s)" ]; then\
	  echo "ERROR: Git repository is in an unclean state.";\
	  exit 1;\
	fi


# Installing targets

install-linux-amd64: remove-binary
	sudo cp -a dist/ntfy_linux_amd64_linux_amd64_v1/ntfy /usr/bin/ntfy

install-linux-armv6: remove-binary
	sudo cp -a dist/ntfy_linux_armv6_linux_arm_6/ntfy /usr/bin/ntfy

install-linux-armv7: remove-binary
	sudo cp -a dist/ntfy_linux_armv7_linux_arm_7/ntfy /usr/bin/ntfy

install-linux-arm64: remove-binary
	sudo cp -a dist/ntfy_linux_arm64_linux_arm64/ntfy /usr/bin/ntfy

remove-binary:
	sudo rm -f /usr/bin/ntfy

=== requirements.txt ===
# The documentation uses 'mkdocs', which is written in Python
mkdocs-material
mkdocs-minify-plugin

=== debian/changelog ===
ntfy (2.11.0-2) unstable; urgency=medium

  * Team upload.

  [ Otto Kekäläinen ]
  * Update gitlab-ci.yml to match the latest one in @go-team/infra/pkg-go-tools

 -- Simon Josefsson <simon@josefsson.org>  Tue, 18 Feb 2025 20:58:19 +0100

ntfy (2.11.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1078571)

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Fri, 17 Jan 2025 20:40:24 +0000

=== debian/control ===
Source: ntfy
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Ahmad Khalifa <ahmad@khalifa.ws>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any (>= 1.19.8),
               golang-github-emersion-go-sasl-dev,
               golang-github-emersion-go-smtp-dev,
               golang-github-gabriel-vasile-mimetype-dev,
               golang-github-gorilla-websocket-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-microcosm-cc-bluemonday-dev,
               golang-github-olebedev-when-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-stretchr-testify-dev <!nocheck>,
               golang-github-urfave-cli-v2-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-term-dev,
               golang-golang-x-time-dev,
               golang-google-api-dev,
               golang-gopkg-yaml.v2-dev
Standards-Version: 4.7.0
Homepage: https://github.com/binwiederhier/ntfy
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-binwiederhier-ntfy
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-binwiederhier-ntfy.git
XS-Go-Import-Path: heckel.io/ntfy

Package: ntfy
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Send push notifications to your phone or desktop
 ntfy (pronounced "notify") is a simple HTTP-based pub-sub notification
 service. With ntfy, you can send notifications to your phone or desktop
 via scripts from any computer, without having to sign up or pay any
 fees. If you'd like to run your own instance of the service, you can
 easily do so since ntfy is open source.
 .
 This package provides the client and server for ntfy.

=== debian/rules ===
#!/usr/bin/make -f

# bring in DEB_VERSION
include /usr/share/dpkg/default.mk

# export DH_VERBOSE = 1
export DH_GOLANG_EXCLUDES = ^\. assets/ docs/ examples/ scripts/ tools/ web/
export DH_GOLANG_INSTALL_EXTRA = server/mailer_emoji_map.json

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

# 1. override version/commit/date, this way --help says something like:
#     ntfy 2.11.0-1 (debian-), runtime go1.23.5, built at 2024-12-15
# 2. show a message when accessing the ntfy web root
# 3. upstream Makefile uses these tags, but skipping:
#    sqlite_omit_load_extension,osusergo,netgo
override_dh_auto_build:
	mkdir -pv _build/src/heckel.io/ntfy/server/docs \
		_build/src/heckel.io/ntfy/server/site
	touch _build/src/heckel.io/ntfy/server/docs/index.html
	echo "<html><body>" \
		"ntfy web root: no web app is running in the debian version" \
		"</body></html>" > \
		_build/src/heckel.io/ntfy/server/site/app.html
	dh_auto_build -- \
		-ldflags "-X main.version=$(DEB_VERSION) -X main.commit=debian- \
			-X main.date=$(shell date -I --date='@$(SOURCE_DATE_EPOCH)')"

override_dh_auto_install:
	dh_auto_install -- --no-source

# install services without enabling or starting them as
# ntfy/ntfy-client are noisy and configured for port 80 by default
override_dh_installsystemd:
	dh_installsystemd --no-start --no-enable --restart-after-upgrade

# Call sysusers because it's not called by standard dh sequence in compat=13
execute_after_dh_installsystemd:
	dh_installsysusers


# Skip tests as they make requests to http://ntfy.sh
# Although they should run as the depends have been tagged
override_dh_auto_test:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
      https://github.com/binwiederhier/ntfy/tags .*/v?(\d\S*)\.tar\.gz debian

# opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
#     https://github.com/binwiederhier/ntfy/tags \
#     (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
